///<reference path="../../../.d.ts"/>
"use strict";
var os = require("os");
var util = require("util");
var ListApplicationsCommand = (function () {
    function ListApplicationsCommand($devicesServices, $logger, $options) {
        this.$devicesServices = $devicesServices;
        this.$logger = $logger;
        this.$options = $options;
        this.allowedParameters = [];
    }
    ListApplicationsCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            _this.$devicesServices.initialize({ deviceId: _this.$options.device, skipInferPlatform: true }).wait();
            var output = [];
            var action = function (device) {
                return (function () {
                    var applications = device.applicationManager.getInstalledApplications().wait();
                    output.push(util.format("%s=====Installed applications on device with UDID '%s' are:", os.EOL, device.deviceInfo.identifier));
                    _.each(applications, function (applicationId) { return output.push(applicationId); });
                }).future()();
            };
            _this.$devicesServices.execute(action).wait();
            _this.$logger.out(output.join(os.EOL));
        }).future()();
    };
    return ListApplicationsCommand;
})();
exports.ListApplicationsCommand = ListApplicationsCommand;
$injector.registerCommand("device|list-applications", ListApplicationsCommand);
