///<reference path="../../../.d.ts"/>
"use strict";
var path = require("path");
var AndroidDeviceFileSystem = (function () {
    function AndroidDeviceFileSystem(adb, identifier, $fs, $logger) {
        this.adb = adb;
        this.identifier = identifier;
        this.$fs = $fs;
        this.$logger = $logger;
    }
    AndroidDeviceFileSystem.prototype.listFiles = function (devicePath) {
        return (function () { }).future()();
    };
    AndroidDeviceFileSystem.prototype.getFile = function (deviceFilePath) {
        return (function () { }).future()();
    };
    AndroidDeviceFileSystem.prototype.putFile = function (localFilePath, deviceFilePath) {
        return (function () { }).future()();
    };
    AndroidDeviceFileSystem.prototype.transferFiles = function (appIdentifier, localToDevicePaths) {
        var _this = this;
        return (function () {
            _(localToDevicePaths)
                .filter(function (localToDevicePathData) { return _this.$fs.getFsStats(localToDevicePathData.getLocalPath()).wait().isFile(); })
                .each(function (localToDevicePathData) { return _this.adb.executeCommand("push \"" + localToDevicePathData.getLocalPath() + "\" \"" + localToDevicePathData.getDevicePath() + "\"").wait(); })
                .value();
            _(localToDevicePaths)
                .filter(function (localToDevicePathData) { return _this.$fs.getFsStats(localToDevicePathData.getLocalPath()).wait().isDirectory(); })
                .each(function (localToDevicePathData) { return _this.adb.executeShellCommand("chmod 0777 \"" + localToDevicePathData.getDevicePath() + "\"").wait(); })
                .value();
        }).future()();
    };
    AndroidDeviceFileSystem.prototype.transferFile = function (localPath, devicePath) {
        var _this = this;
        return (function () {
            _this.$logger.trace("Transfering " + localPath + " to " + devicePath);
            var stats = _this.$fs.getFsStats(localPath).wait();
            if (stats.isDirectory()) {
                _this.adb.executeShellCommand("mkdir \"" + path.dirname(devicePath) + "\"").wait();
            }
            else {
                _this.adb.executeCommand("push \"" + localPath + "\" \"" + devicePath + "\"").wait();
            }
        }).future()();
    };
    return AndroidDeviceFileSystem;
})();
exports.AndroidDeviceFileSystem = AndroidDeviceFileSystem;
