///<reference path=".d.ts"/>
"use strict";
require("./bootstrap");
var fiber = require("fibers");
var Future = require("fibers/future");
var errors = require("./common/errors");
errors.installUncaughtExceptionListener();
fiber(function () {
    var config = $injector.resolve("$config");
    var err = $injector.resolve("$errors");
    err.printCallStack = config.DEBUG;
    var commandDispatcher = $injector.resolve("commandDispatcher");
    if (process.argv[2] === "completion") {
        commandDispatcher.completeCommand().wait();
    }
    else {
        commandDispatcher.dispatchCommand().wait();
    }
    $injector.dispose();
    Future.assertNoFutureLeftBehind();
}).run();
